︠1dfdef33-21fe-4d90-a528-c96661224e88is︠
%auto
%hide
html('<style>code {background:#FFFF99 !important}</style>')
def multiple_choice_quiz(s):
    hide()
    # a comma seperated string where the sub string wrapped in quotes is the answer

    choices = [choice.strip() for choice in s.split(',')]
    question = choices.pop(0)
    answer = ''
    for choice in choices:
        if choice.startswith('*') and choice.endswith('*'):
            answer = choice.strip('*')
            choices = [''] + choices
            choices[choices.index(choice)] = choice.strip('*')

    def q(choice=selector(choices, label=question, buttons=True)):
        if choice == answer:
            print 'Correct'
        elif not choice:
            print ''
        else:
            print 'Incorrect'
    interact(q)

def exact_text_match_quiz(question, answer, starter_answer='', hint=False, hint_label='', hint_response=''):
    hide()
    
    if hint:
        def q(students_answer=input_box(starter_answer, label=question, type=str), h=button(hint_label, label='', classes="btn-primary btn-large")):
            if 'h' in interact.changed():
                print hint_response
            else:
                if students_answer and students_answer != starter_answer:
                    if students_answer == answer:
                        print 'Correct'
                    else:
                        print 'Incorrect'
    else:
        def q(students_answer=input_box(starter_answer, label=question, type=str)):
            if students_answer:
                if students_answer == answer:
                    print 'Correct'
                else:
                    print 'Incorrect'
    interact(q)
︡edbbbe96-ee4f-4cdc-bbb9-720cd4f86c2b︡{"hide":"input"}︡{"html":"<style>code {background:#FFFF99 !important}</style>"}︡{"done":true}︡{"done":true}︡
︠69859faa-2c64-4d26-a2c1-c966f2507aaci︠
%md
# Intro to Python for new users of Sage
︡782f3e85-7373-4553-9a8f-3c1069a4f6cc︡{"done":true,"md":"# Intro to Python for new users of Sage"}
︠4d146a83-8407-4b90-8ee7-defc2d54e867i︠
%md
## Preface
Sage is math software that uses the world's fourth most popular programming language, Python, see http://www.tiobe.com/tiobe_index Unlike the first three most popular programming languages Python can be used interactively. Also the commerical math software systems like Mathematica and MATLAB use their own languages. By using Sage you're using/learning Python which will be useful in general.

This intro to Python for users of Sage on the SageMathCloud. Therefore we will do all the coding inside a Sage worksheet.
︡bfccf183-b1c7-4c79-9d49-7f102cf94208︡{"done":true,"md":"## Preface\nSage is math software that uses the world's fourth most popular programming language, Python, see http://www.tiobe.com/tiobe_index Unlike the first three most popular programming languages Python can be used interactively. Also the commerical math software systems like Mathematica and MATLAB use their own languages. By using Sage you're using/learning Python which will be useful in general.\n\nThis intro to Python for users of Sage on the SageMathCloud. Therefore we will do all the coding inside a Sage worksheet."}
︠125e44b3-bb1c-45de-8870-b747dc09dcb9i︠
%md
## Chapter 1. Getting Python to say things

In this lesson you will learn:
 - how to execute code within Sage
 - the importance of syntax
 - common errors
 - strings
 - how to code strings with special characters

**Key Terms**


 - Print
 - Syntax
 - String
 - Escaping

︡36bd6171-b9fc-4de9-a524-0c6bdda6d85e︡{"done":true,"md":"## Chapter 1. Getting Python to say things\n\nIn this lesson you will learn:\n - how to execute code within Sage\n - the importance of syntax\n - common errors\n - strings\n - how to code strings with special characters\n\n**Key Terms**\n\n\n - Print\n - Syntax\n - String\n - Escaping"}
︠54b690d8-0e33-45dd-92a4-6e537afe399fi︠
%md
### Lesson 1. Executing code
Click under this box where it says `print "Hello world"` and hit SHIFT-ENTER at the same time.
The light gray bar on the side will become green. Sage will run the program, and the results will show underneath.

Defining _**print**_ - the way that python displays something
︡e8e5d063-77c8-499d-80c0-02999e44525d︡{"done":true,"md":"### Lesson 1. Executing code\nClick under this box where it says `print \"Hello world\"` and hit SHIFT-ENTER at the same time. \nThe light gray bar on the side will become green. Sage will run the program, and the results will show underneath.\n\nDefining _**print**_ - the way that python displays something"}
︠0432881e-103a-4daf-ad92-38545a35f0cc︠
print "Hello world"
︡9e4ac724-e40d-48d0-a810-803243b39025︡
︠c9103c3a-8ba7-4377-a62c-fd7007c69d80i︠
%md
### Lesson 2. The importance of syntax
Defining **_syntax_** - the set of rules that the computer follows to run code.

In lesson one you did the classical Hello World that any coding tutorial will have you do. Now we're going to debilerately execute invalid code to learn about syntax errors.

Type the code from line 37 below this box. **Remove the quotes.** Execute the code using what you learned in the first box. Do not copy and paste as this is an exercise in the importance of syntax.
︡7a34218f-ee77-420c-942b-c85657874cc9︡{"done":true,"md":"### Lesson 2. The importance of syntax\nDefining **_syntax_** - the set of rules that the computer follows to run code.\n\nIn lesson one you did the classical Hello World that any coding tutorial will have you do. Now we're going to debilerately execute invalid code to learn about syntax errors.\n\nType the code from line 37 below this box. **Remove the quotes.** Execute the code using what you learned in the first box. Do not copy and paste as this is an exercise in the importance of syntax."}
︠b8b903cf-1a76-40d2-93dd-f6ab33e63efb︠
#type the code underneath this comment:

︡66a426be-2c1e-4012-b5d2-591024d290aa︡{"done":true}︡
︠ae713cd1-9872-48f9-89ac-64b203ff3eaa︠
%md
You should have gotten your first error. You will see errors a lot when you code. As you learn from examples you'll need to copy the examples exactly or you'll get an error because Python has a very strict syntax.

The error you got should look like:
```
Error in lines 1-1
Traceback (most recent call last):
  File "/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py", line 905, in execute
    exec compile(block+'\n', '', 'single') in namespace, locals
  File "<string>", line 1
    print Hello world
                    ^
SyntaxError: invalid syntax
```



Notice that the error doesn't say what you're missing, but it does show you _where_ the error is by using a ^. In this case, the error is in print hello world. Because of this you're going to have to memorize Python's basic syntax.
︡a86f1ce6-052a-47ae-9701-bab5b8215ab3︡{"done":true,"md":"You should have gotten your first error. You will see errors a lot when you code. As you learn from examples you'll need to copy the examples exactly or you'll get an error because Python has a very strict syntax.\n\nThe error you got should look like:\n```\nError in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"<string>\", line 1\n    print Hello world\n                    ^\nSyntaxError: invalid syntax\n```\n\n\n\nNotice that the error doesn't say what you're missing, but it does show you _where_ the error is by using a ^. In this case, the error is in print hello world. Because of this you're going to have to memorize Python's basic syntax."}
︠c99ab332-d238-451f-81ed-8387ff064e7e︠
%md
### Lesson 3. Strings
A _**string**_ is a list of characters. This could be one character, a word, a sentence, a paragrah, or longer. It could have numbers or special characters as well. When you want to print a string, you need to start that string with either a `'` or `"` and end it which ever you started it with.


︡ba340ff8-bc1f-4fa8-ae00-d71058455951︡{"done":true,"md":"### Lesson 3. Strings\nA _**string**_ is a list of characters. This could be one character, a word, a sentence, a paragrah, or longer. It could have numbers or special characters as well. When you want to print a string, you need to start that string with either a `'` or `\"` and end it which ever you started it with."}
︠30c8dfe7-e3db-4564-88a1-fc526b873bbb︠

︡3312c1d4-2845-446e-88c3-c0afc36bb2a5︡
︠91258948-8c1b-49c0-9c9d-4aadbe079252is︠
%auto
%multiple_choice_quiz
Which of the following is not a valid string?,*'Blah blah"*,"I'm a string!",'Rar!!!',"5+5=10"
︡9d37d807-c10f-4d55-a9e9-4f202a9be387︡{"hide":"input"}︡{"interact":{"controls":[{"button_classes":null,"buttons":true,"control_type":"selector","default":0,"label":"Which of the following is not a valid string?","lbls":["","'Blah blah\"","\"I'm a string!\"","'Rar!!!'","\"5+5=10\""],"ncols":null,"nrows":null,"var":"choice","width":null}],"flicker":false,"id":"cb47f0c5-c36a-42c2-8562-e85da86c04c8","layout":[[["choice",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠e8216b6a-164c-4809-8fce-5335bff3501ei︠
%md
### Lesson 4. Dealing with special characters
There are special characters that we sometimes need to deal with in order to create a valid string.  We are now going to look at some invalid strings, then discuss how to change them.
<style>.blue {background:#b1ebff;} </style>

These are not valid strings:
 - `'Sarah isn`<span class="blue"> '</span>`t her name.'` because Python in this case thinks the string stops at the <span class ="blue"> ' </span> in `isn't`.
 - `"He said `<span class="blue">"</span>`He's going home.`<span class="blue">" </span>`"` because Python in this case thinks the string stops at the <span class="blue"> "</span> found in the dialogue`"He's going home"`.
<br/>
<br/>

To make a valid string, you need to change the string. Below are ways to change invalid strings. One way of doing this is adding a `\`. This is called _**escaping**_.

 - put a <span class="blue">\ </span> in front of the `'`in isn't.<br/>`'Sarah isn`<span class ="blue">\</span>`'t her name.'`
<br/><br/>
_**OR**_
<br/> <br/>
 - change the <span class="blue">'</span> at the beginning and end to `"`<br/><span class="blue">"</span> `Sarah isn't her name.`<span class ="blue">"</span>
<br/> <br/>

For the second example, there are also two fixes:
<br/>
 - you need to put a <span class="blue"> \</span> in front of the `"` that show dialogue <br/>
 `"He said` <span class="blue"> \</span>`"He's going home.` <span class="blue"> \</span>"`"`
<br/><br/>
_**OR**_
<br/> <br/>
 - change the <span class="blue">" </span> at the beginning and end to `'` then put a <span class="blue"> \ </span> in front of the `'` in he's
<br/>
<span class ="blue">'</span>`He said "He`<span class="blue"> \</span>`'s going home."`<span class ="blue">'</span>

︡02b15fc4-b629-49cc-946a-c4d95f6e3595︡{"done":true,"md":"### Lesson 4. Dealing with special characters\nThere are special characters that we sometimes need to deal with in order to create a valid string.  We are now going to look at some invalid strings, then discuss how to change them. \n<style>.blue {background:#b1ebff;} </style>\n\nThese are not valid strings:\n - `'Sarah isn`<span class=\"blue\"> '</span>`t her name.'` because Python in this case thinks the string stops at the <span class =\"blue\"> ' </span> in `isn't`.\n - `\"He said `<span class=\"blue\">\"</span>`He's going home.`<span class=\"blue\">\" </span>`\"` because Python in this case thinks the string stops at the <span class=\"blue\"> \"</span> found in the dialogue`\"He's going home\"`.\n<br/>\n<br/>\n\nTo make a valid string, you need to change the string. Below are ways to change invalid strings. One way of doing this is adding a `\\`. This is called _**escaping**_.\n\n - put a <span class=\"blue\">\\ </span> in front of the `'`in isn't.<br/>`'Sarah isn`<span class =\"blue\">\\</span>`'t her name.'`\n<br/><br/>\n_**OR**_\n<br/> <br/>\n - change the <span class=\"blue\">'</span> at the beginning and end to `\"`<br/><span class=\"blue\">\"</span> `Sarah isn't her name.`<span class =\"blue\">\"</span>\n<br/> <br/>\n\nFor the second example, there are also two fixes:\n<br/>\n - you need to put a <span class=\"blue\"> \\</span> in front of the `\"` that show dialogue <br/>\n `\"He said` <span class=\"blue\"> \\</span>`\"He's going home.` <span class=\"blue\"> \\</span>\"`\"`\n<br/><br/>\n_**OR**_\n<br/> <br/>\n - change the <span class=\"blue\">\" </span> at the beginning and end to `'` then put a <span class=\"blue\"> \\ </span> in front of the `'` in he's\n<br/> \n<span class =\"blue\">'</span>`He said \"He`<span class=\"blue\"> \\</span>`'s going home.\"`<span class =\"blue\">'</span>"}
︠21cb6996-8b43-4164-83ab-02c663601c87︠

︡8e215707-38e9-45be-89ba-31e5b488d50f︡{"done":true}︡
︠25a60913-e54e-4187-b3ba-2b0a54abc896is︠
%auto
exact_text_match_quiz('This is an invalid string. Change the string using what you learned above then press ENTER', "'Doug isn\\'t coming home today afterall.'", "'Doug isn't coming home today afterall.'", hint=True, hint_label="I don't see anything wrong with the string", hint_response="Reread the lesson")
︡e1266712-8015-4ae9-9942-ec0159cd54df︡{"hide":"input"}︡{"interact":{"controls":[{"control_type":"input-box","default":"'Doug isn't coming home today afterall.'","label":"This is an invalid string. Change the string using what you learned above then press ENTER","nrows":1,"readonly":false,"submit_button":null,"type":"<type 'str'>","var":"students_answer","width":null},{"classes":"btn-primary btn-large","control_type":"button","default":"I don't see anything wrong with the string","icon":null,"label":"","var":"h","width":null}],"flicker":false,"id":"0a0bf54b-3ed5-4836-8ab7-2e9873e87a28","layout":[[["students_answer",12,null]],[["h",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠4d71649c-d775-422e-82e6-676b212d3e8b︠










